;"SATYR SERVER"
;"Installation script for Minimal.db"
;"Created by Jon S. <jon@bzap.org>"
;"http://www.centaur.pw/ and https://www.bzap.org/"
;"Version 1.0 -- April 3, 2020"

;"Once installed, to login to the database for the first time, enter at login prompt:"
;"	admin PASSWORD	"

;"Intended for use with the LambdaMOO-1.8.1-Centaur source compiled"
;"on a Linux machine."

;"Please take the time to review the comments (beginning with ;) in this file and make any"
;"necessary changes before pasting it to a running Minimal.db. Be sure to review the"
;"properties on $server_options and the ANSI color properties."

;"When the installation is complete, you are logged out of the server."
;"To reconnect, enter 'admin PASSWORD' (exactly as shown) at the login screen."

;"Review the output. If there are any errors, fix them in this script, shut down the server,"
;"and reload it with a new Minimal.db. Ignore the 'Line 1:  syntax error' message at the end"
;"between the lines for temporary reprogramming of #0:do_command."

;"Then you may begin modifying the database."

;"Download LambdaMOO-1.8.1-Centaur at:"
;"http://www.centaur.pw/satyr/LambdaMOO_Centaur-1.8.1.tar.gz"

;"See the file 'README.Centaur' in the above archive for complete instructions."

;"This is the original LambdaMOO 1.8.1 source code with the File Utilities Package 1.8"
;"and Unicode (UTF-8) support."

;"The file 'ext-FUP_options.h' in the above archive is set up to use the / directory"
;"as a base for file access. The options in that file may be changed before compiling."

;"By default, the compiled 'lmc' binary should be placed in a directory in the / directory (e.g. /satyr)"
;"along with the database. If you are using a different directory, you need to change the"
;"values in the first block of add_property statements."

;"The files 'ansicolor', 'login' and 'motd' *must* be located in the same"
;"directory as the databases. 'ansicolor' is included in the LambdaMOO_Centaur source code archive."
;"You need to create a 'bin' directory in the same directory for commands requiring filerun() to work."

;"If $server_options.use_login_file is true and a file named 'login' is in the directory,"
;"that text, with any escape characters, is displayed upon connection rather than the text"
;"of $server_options.login_screen."

;"If a file named 'motd' exists in the server directory, its contents, with any escape characters,"
;"is displayed upon login. No properties need to be modified."

;"Color tags are not interpreted until the appropriate properties"
;"have been set and #1:notify has been programmed."

;"This first version of 'eval' uses only primitive commands and contains no color tags."

.program #2:eval
if (!player.wizard || !player.programmer)
return notify(player, "You do not have permission to use eval.");
endif
return notify(player, tostr("-> ", toliteral(eval("return " + argstr + ";")[2])));
.

;#2.name = "Main Room"
;#2.r = 1
;#2.f = 1
;#3.name = "Root User"

;add_verb(#1, {#3, "rxd", "notify"}, {"this", "none", "this"})
;add_verb(#3, {#3, "rxd", "notify"}, {"this", "none", "this"})
;add_verb(#3, {#3, "rxd", "notify_lines"}, {"this", "none", "this"})
;add_verb(#3, {#3, "rxd", "notify_lines_nocolor"}, {"this", "none", "this"})
;add_verb(#0, {#3, "rxd", "color"}, {"this", "none", "this"})
;add_verb(#0, {#3, "rxd", "liststr"}, {"this", "none", "this"})
;add_verb(#0, {#3, "rxd", "listspc"}, {"this", "none", "this"})
;add_verb(#0, {#3, "rxd", "obj"}, {"this", "none", "this"})
;add_verb(#0, {#3, "rxd", "getobj"}, {"this", "none", "this"})

;"Adds properties for the ANSI color codes and sets them to the correct codes"
;"from the 'ansicolor' file."

;"Be certain the file 'ansicolor' is in the same directory as the databases."
;"Change the '/satyr' values below to something different if necessary"
;"*before* running this block.";

;add_property(#0, "black", fileread("/satyr", "ansicolor")[1], {#3, "rc"})
;add_property(#0, "red", fileread("/satyr", "ansicolor")[2], {#3, "rc"})
;add_property(#0, "green", fileread("/satyr", "ansicolor")[3], {#3, "rc"})
;add_property(#0, "yellow", fileread("/satyr", "ansicolor")[4], {#3, "rc"})
;add_property(#0, "blue", fileread("/satyr", "ansicolor")[5], {#3, "rc"})
;add_property(#0, "purple", fileread("/satyr", "ansicolor")[6], {#3, "rc"})
;add_property(#0, "cyan", fileread("/satyr", "ansicolor")[7], {#3, "rc"})
;add_property(#0, "white", fileread("/satyr", "ansicolor")[8], {#3, "rc"})
;add_property(#0, "bold", fileread("/satyr", "ansicolor")[9], {#3, "rc"})
;add_property(#0, "underline", fileread("/satyr", "ansicolor")[10], {#3, "rc"})
;add_property(#0, "reset", fileread("/satyr", "ansicolor")[$], {#3, "rc"})

;"Properties required by the user."

;add_property(#3, "color", 1, {#3, "rc"});
;add_property(#3, "modules", {}, {#3, "rc"});
;add_property(#3, "password", "C2lbuVajaTnog", {#3, "rc"})
;add_property(#3, "prompt", 1, {#3, "rc"})
;add_property(#3, "email", "(not set)", {#3, "rc"})
;add_property(#3, "mail", {}, {#3, "rc"})
;add_property(#3, "newmail", 0, {#3, "rc"})
;add_property(#3, "talk", 1, {#3, "rc"});
;add_property(#3, "rootdir", "/satyr", {#3, "rc"})
;add_property(#3, "realname", "(not set)", {#3, "rc"})

.program #1:notify
if (!args)
  return notify(this, "");
else
  s = "";
  for x in (args)
    s = s + tostr(x);
  endfor
  if (player.color)
    c = {$black, $red, $green, $yellow, $blue, $purple, $cyan, $white, $bold, $underline, $reset};
    s = strsub(s, ":black:", c[1]);
    s = strsub(s, ":red:", c[2]);
    s = strsub(s, ":green:", c[3]);
    s = strsub(s, ":yellow:", c[4]);
    s = strsub(s, ":blue:", c[5]);
    s = strsub(s, ":purple:", c[6]);
    s = strsub(s, ":cyan:", c[7]);
    s = strsub(s, ":white:", c[8]);
    s = strsub(s, ":bold:", c[9]);
	s = strsub(s, ":underline:", c[10]);
    s = strsub(s, ":reset:", c[$]);
  else
    s = strsub(s, ":black:", "");
    s = strsub(s, ":red:", "");
    s = strsub(s, ":green:", "");
    s = strsub(s, ":yellow:", "");
    s = strsub(s, ":blue:", "");
    s = strsub(s, ":purple:", "");
    s = strsub(s, ":cyan:", "");
    s = strsub(s, ":white:", "");
    s = strsub(s, ":bold:", "");
	s = strsub(s, ":underline:", "");
    s = strsub(s, ":reset:", "");
  endif
  return notify(this, s);
endif
.

.program #0:liststr
if (!args)
  return "";
endif
s = "";
for x in (args)
  if (x != args[$])
    s = s + tostr(x) + ", ";
  else
    s = s + tostr(x);
  endif
endfor
return s;
.

.program #0:listspc
if (!args)
  return "";
endif
s = "";
for x in (args)
  if (x != args[$])
    s = s + tostr(x) + " ";
  else
    s = s + tostr(x);
  endif
endfor
return s;
.

.program #0:obj
if (!length(args))
return #-1;
endif
a = args[1];
if (a[1] == "#")
return toobj(a);
elseif (a[1] == "$")
if (b = a[2..$] in (properties(#0)))
return toobj(#0.(a[2..$]));
else
return #-3;
endif
else
return #-3;
endif
.

.program #0:getobj
if (args[1] == "me")
object = player;
elseif (args[1] == "here")
object = player.location;
else
object = $obj(args[1]);
endif
return object;
.

;add_verb(#3, {#3, "rxd", "@verb"}, {"any", "any", "any"})

.program #3:@verb
if ((!argstr) || (length(args) < 5))
return player:notify(":bold::red:Usage: ", verb, " <obj> <name> <args1> <args2> <args3>:reset:");
endif
try
object = $getobj(args[1]);
add_verb(object, {#3, "rxd", args[2]}, {args[3], args[4], args[5]});
player:notify(":bold::green:Verb \"", args[2], "\" added ", "with arguments \"", args[3], " ", args[4], " ", args[5], "\".:reset:");
except (ANY)
player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #3 @args any any any

.program #3:@args
if (length(args) < 2)
  return player:notify(":bold::red:Usage: ", verb, " <obj> <verb> [args1] [args2] [args3]:reset:");
endif
try
  o = $getobj(args[1]);
  if (length(args) == 2)
    player:notify(":bold::green:", tostr(o), ":", args[2], " arguments: {", verb_args(o, args[2])[1], " ", verb_args(o, args[2])[2], " ", verb_args(o, args[2])[3], "}:reset:");
  elseif (length(args) == 5)
    set_verb_args(o, args[2], {args[3], args[4], args[5]});
    player:notify(":bold::green:", tostr(o), ":", args[2], " arguments set to {", verb_args(o, args[2])[1], " ", verb_args(o, args[2])[2], " ", verb_args(o, args[2])[3], "}:reset:");
  else
    return player:notify(":bold::red:Usage: ", verb, " <obj> <verb> [args1] [args2] [args3]:reset:");  
  endif
except (ANY)
  return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #3 @verbinfo any any any

.program #3:@verbinfo
if (length(args) < 2)
  return player:notify(":bold::red:Usage: ", verb, " <obj> <verb> [owner] [perms] [\"name\"]:reset:");
endif
try
  o = $getobj(args[1]);
  if (length(args) == 2)
    player:notify(":bold::green:", tostr(o), ":", args[2], " information: {", tostr(verb_info(o, args[2])[1]), " ", verb_info(o, args[2])[2], " ", verb_info(o, args[2])[3], "}:reset:");
  elseif (length(args) == 5)
    set_verb_info(o, args[2], {toobj(args[3]), args[4], args[5]});
    player:notify(":bold::green:", tostr(o), ":", args[2], " owner, permissions, and name set to {", tostr(toobj(args[3])), " ", args[4], " ", args[5], "}:reset:");
  else
    return player:notify(":bold::red:Usage: verbinfo <obj> <verb> [owner] [perms] [\"name\"]:reset:");
  endif
except (ANY)
  return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #3 @cfile any any any

.program #3:@cfile
if (length(args) < 3)
  return player:notify(":bold::red:Usage: ", verb, " <obj> <verb> [dir] <filename>:reset:");
endif
v = args[2];
object = $getobj(args[1]);
if (length(args) == 4)
  path = args[3];
  file = args[4];
elseif (length(args) == 3)
  path = player.rootdir;
  file = args[3];
endif
if (!valid(object))
  return player:notify(":bold::red:Invalid object.:reset:");
endif
if (!v in verbs(object))
  return player:notify(":bold::red:Verb not found on that object.:reset:");
endif
if (fileexists(path, file))
  return player:notify(":bold::red:File ", file, " already exits in path /", path, ". Choose another name or path.:reset:");
endif
try
  y = {};
  x = tostr(".program " + tostr(object) + ":" + v);
  for z in (verb_code(object, v))
    y = listappend(y, z);
  endfor
  w = {x, @y, "."};
  filewrite(path, file, w);
  player:notify(":bold::green:", file, " written to directory /", path, ".:reset:");
  return;
except (ANY)
  return player:notify(":bold::red:Command failed.:reset:");
endtry
.

@verb #3 @fcode any any any

.program #3:@fcode
if (length(args) != 4 && length(args) != 3)
  return player:notify(":bold::red:Usage: ", verb, " [path] <file> <obj> <verb>:reset:");
endif
if (length(args) == 4)
  path = args[1];
  file = args[2];
elseif (length(args) == 3)
  path = player.rootdir;
  file = args[1];
endif
if (!fileexists(path, file))
  return player:notify(":bold::red:File not found.:reset:");
endif
object = $getobj(args[3]);
v = args[4];
if (!valid(object))
  return player:notify(":bold::red:Invalid object.:reset:");
endif
if (!file in verbs(object))
  return player:notify(":bold::red:Verb not found on that object.:reset:");
endif
sv = set_verb_code(object, v, fileread(path, file)[2..length(fileread(path, file)) - 1]);
if (!sv)
  player:notify(":bold::green:", tostr(object), ":", v, " programmed.:reset:");
  return;
else
  if (typeof(sv) == LIST && length(sv) > 1)
    player:notify_lines_nocolor(sv);
  else
    player:notify(sv[1]);
  endif
  return player:notify(":bold::red:", tostr(length(sv)), " error(s). Not programmed.:reset:");
endif
return player:notify(":bold::red:Unspecified error.:reset:");
.

@verb #3 @script any any any

.program #3:@script
if (length(args) != 2 && length(args) != 1)
  return player:notify(":bold::red:Usage: ", verb, " [path] <file>:reset:");
endif
if (length(args) == 2)
  path = args[1];
  file = args[2];
elseif (length(args) == 1)
  path = player.rootdir;
  file = args[1];
endif
if (!fileexists(path, file))
  return player:notify(":bold::red:File not found.:reset:");
endif
if (player.prompt)
  player:notify(":bold::red:<Prompt disabled.>:reset:");
  player.prompt = 0;
endif
for x in (fileread(path, file))
  force_input(player, x);
endfor
.

@verb #3 @mkadmin any any any

.program #3:@mkadmin
if (length(args) < 3)
  return player:notify(":bold::red:Usage: ", verb, " <name> <password> <email>:reset:");
endif
users = {};
for x in (players())
  users = listappend(users, x.name);
endfor
if (args[1] in users)
  return player:notify(":bold::red:User ", args[1], " already exists. Please choose another name.:reset:");
endif
u = create($admin);
set_player_flag(u, 1);
u.name = args[1];
u.password = crypt(args[2], $server_options.salt);
u.email = args[3];
u.owner = u;
u.programmer = 1;
u.wizard = 1;
move(u, $user_start);
chparent(u, $admin);
player:notify(":bold::green:User ", args[1], " (", tostr(u), ") created. Password and e-mail set.:reset:");
.

@verb #3 @mkuser any any any

.program #3:@mkuser
if (length(args) < 3)
  return player:notify(":bold::red:Usage: ", verb, " <name> <password> <email>:reset:");
endif
users = {};
for x in (players())
  users = listappend(users, x.name);
endfor
if (args[1] in users)
  return player:notify(":bold::red:User ", args[1], " already exists. Please choose another name.:reset:");
endif
u = create($user);
set_player_flag(u, 1);
u.name = args[1];
u.password = crypt(args[2], $server_options.salt);
u.email = args[3];
u.owner = u;
move(u, $user_start);
player:notify(":bold::green:User ", args[1], " (", tostr(u), ") created. Password and e-mail set.:reset:");
.

@verb #3 @users any any any

.program #3:@users
player:notify(":bold::blue:Registered users (", tostr(length(players())), ")::reset:");
for x in (players())
  if (x != $admin && x != $user)
    player:notify(":cyan:", x.name, " (", tostr(x), ") [", parent(x).name, "]:reset:");
  endif
endfor
.

;"A version of 'eval' that uses color and player:notify() replaces the earlier one."

.program #2:eval
if (!player.wizard || !player.programmer)
return player:notify(":bold::red:You do not have permission to use eval.:reset:");
endif
return player:notify(tostr(":bold::cyan:-> ", toliteral(eval("return " + argstr + ";")[2]), ":reset:"));
.

;"You may delete the 'ansicolor' file once the codes have been sucessfully imported if desired."
;"Best to check they were imported correctly first."

.program #3:notify
pass(@args);
.

.program #3:notify_lines
try
for x in ((args[1]))
this:notify(tostr(x));
endfor
except (ANY)
return this:notify("??");
endtry
.

.program #3:notify_lines_nocolor
try
for x in ((args[1]))
notify(this, tostr(x));
endfor
except (ANY)
return notify(this, "??");
endtry
.

.program #0:color
c = {$black, $red, $green, $yellow, $blue, $purple, $cyan, $white, $bold, $underline, $reset};
if (args[1] == 1 || args[1] == "black")
  return c[1];
elseif (args[1] == 2 || args[1] == "red")
  return c[2];
elseif (args[1] == 3 || args[1] == "green")
  return c[3];
elseif (args[1] == 4 || args[1] == "yellow")
  return c[4];
elseif (args[1] == 5 || args[1] == "blue")
  return c[5];
elseif (args[1] == 6 || args[1] == "purple")
  return c[6];
elseif (args[1] == 7 || args[1] == "cyan")
  return c[7];
elseif (args[1] == 8 || args[1] == "white")
  return c[8];
elseif (args[1] == 9 || args[1] == "bold")
  return c[9];
elseif (args[1] == 10 || args[1] == "underline")
  return c[10];
elseif (args[1] == 0 || args[1] == "reset")
  return c[$];
else
  return c[$];
endif
.

@verb #2 say any any any

.program #2:say
if (!argstr)
  return player:notify(":bold::red:Usage: ", verb, " <message>:reset:");
endif
if (!player.talk)
  return player:notify(":bold::red:Your talk option is OFF. Use 'talk on' to switch to ON.:reset:");
endif
s = tostr(":green:[:bold::blue:", player.name, ":reset::green:] :bold::cyan:", argstr, ":reset:");
for x in (connected_players())
  if (x.talk)
    x:notify(s);
  endif
endfor
.

@verb #0 do_command this none this

.program #0:do_command
try
d = {"north", "south", "east", "west", "northeast", "northwest", "southeast", "southwest", "up", "down", "n", "s", "e", "w", "ne", "nw", "se", "sw", "u", "d"};
a = {};
if (argstr in (d))
return 0;
endif
for z in (args)
  if (z != args[1])
    a = listappend(a, z);
  endif
endfor
if (args[1][1] != "@" && args[1][1] != ";")
  player.location:say(@args);
  return 1;
elseif (args[1][1] == "@" && !args[1][1] != ";")
  for x in (player.modules)
    for y in (verbs(x))
      if (args[1] == y)
        x:(y)(@a);
        return 1;
      endif
    endfor
  endfor
else
  if (player.prompt)
    string = ":cyan:" + player.name + ":purple:@:cyan:" + player.location.name + ":purple:>:bold::purple:" + $listspc(@args) + ":reset:";
    player:notify(string);
    return 0;
  else
    return 0;
  endif
endif
except (ANY)
return 0;
endtry
.

@verb #0 users this none this

.program #0:users
uname = {};
unum = {};
for u in (players())
  uname = listappend(uname, u.name);
  unum = listappend(unum, u);
endfor
return {unum, uname};
.

@verb #0 day this none this

.program #0:day
d = tostr(ctime()[9..10]);
if (d[1] == " ")
  x = "0" + d[2];
else
  x = d;
endif
return x;
.

@verb #0 year this none this

.program #0:year
return tostr(ctime()[21..24]);
.

@verb #0 date this none this

.program #0:date
q = ctime()[5..7];
i = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
e = q in i;
if (length(tostr(e)) < 2)
  e = "0" + tostr(e);
else
  e = tostr(e);
endif
st = tostr(e, "/", $day(), "/", $year());
return st;
.

@verb #3 @prop any any any

.program #3:@prop
if ((!argstr) || (length(args) < 3))
return player:notify(tostr(":bold::red:Usage: ", verb, " <obj> <name> <value>:reset:"));
endif
try
object = $getobj(args[1]);
if (args[2] in (properties(object)))
return player:notify(":bold::red:Property '", args[2], " 'already exists on ", object.name, " (", tostr(object), ").:reset:");
endif
if (args[3][1] == "#")
add_property(object, tostr(args[2]), toobj(args[3]), {player, "rc"});
elseif (!toint(args[3]) && args[3] != "" && args[3] != "0")
add_property(object, tostr(args[2]), tostr(args[3]), {player, "rc"});
elseif (index(args[3], ".") && index(args[3], ".") != args[3][$])
add_property(object, tostr(args[2]), tofloat(args[3]), {player, "rc"});
else
add_property(object, tostr(args[2]), toint(args[3]), {player, "rc"});
endif
if (typeof(object.(args[2])) == STR)
player:notify(tostr(":bold::green:Property ", object.name, " (", tostr(object), ").", args[2], " created with value \"", args[3], "\".:reset:"));
else
player:notify(tostr(":bold::green:Property ", object.name, " (", tostr(object), ").", args[2], " created with value ", args[3], ".:reset:"));
endif
except (ANY)
return player:notify(":bold::red:Failed to add property.:reset:");
endtry
.

@verb #3 readlines this none this

.program #3:readlines
player:notify(":bold::green:<Input text. Send '.' when finished.>:reset:");
i = {};
w = "";
while (w != ".")
w = read();
if (w != ".")
i = listappend(i, w);
endif
endwhile
player:notify(":bold::green:<Input written.>:reset:");
return i;
.

@verb #3 yesno this none this

.program #3:yesno
player:notify(":yellow:<Input 'yes' [y] or 'no' [n]>:reset:");
yn = read();
if (yn == "yes" || yn == "y")
  return 1;
else
  return 0;
endif
.

@verb #3 addr this none this

.program #3:addr
return connection_name(player)[16..index(connection_name(player), ",") - 1];
.

;"$admin and $user will be changed later."

@prop #0 admin #3
@prop #0 user #3
@prop #0 room #2
@prop #0 user_start #2

;"Server Options object is now created."
;"You may want to change the values of several of these properties."
;"If you intend to use a login screen file (called 'login' in the server directory) rather than the property,"
;"it is not necessary to set $server_options.login_screen."

;"NOTE: You cannot initialize a property as a list with the '@prop' command."

;create(#1)
;#4.name = "Server Options"
@prop #0 server_options #4

@prop $server_options login_screen 0
;$server_options.login_screen = {"Satyr Server", "", "Login Commands", "--------------", "<user> <password> -- Connect to an existing account.", "create <username> <password> <email-address> -- Create a new account", "quit -- Disconnect from the server"}
@prop $server_options directory "/satyr"
@prop $server_options site "site.com"
@prop $server_options port 2000
@prop $server_options huh_msg "<Unknown command.>"
@prop $server_options confirm_delete 1
@prop $server_options connect_msg "User connected."
@prop $server_options boot_msg "User disconnected."
@prop $server_options create_msg "User created."
@prop $server_options recycle_msg "Your account has been deleted."
@prop $server_options redirect_from_msg "Account logged in from another location. Redirecting connection to that port."
@prop $server_options redirect_to_msg "Account logged in from another location. Redirecting connection to this port."
@prop $server_options timeout_msg "Authentication timeout."

;"Set to 1 to use file 'login' for the login screen. This file must be located in $server_options.directory."
@prop $server_options use_login_file 0

;"Set to 0 to disable user creation at the login screen."
@prop $server_options login_create 1

@prop $server_options salt "C2"
@prop $server_options bin "/satyr/bin"
@prop $server_options bg_seconds 120
@prop $server_options fg_seconds 120
@prop $server_options bg_ticks 2000000
@prop $server_options fg_ticks 2000000
@prop $server_options dbfile "Satyr.current.db"

@verb #2 huh this none this

.program #2:huh
return player:notify(":bold::red:", $server_options.huh_msg, ":reset:");
.

@verb #3 @color any any any
@verb #3 @talk any any any
@verb #3 @prompt any any any

.program #3:@color
if (argstr != "on" && argstr != "off")
  player:notify(":bold::red:Usage: ", verb, " <on|off>:reset:");
  player:notify(":bold::blue:Current setting::reset: ", player.color ? ":bold::green:ON:reset:" | "OFF");
  return;
endif
state = player.color;
if (argstr == "on" && state)
  return player:notify(":bold::red:Color is already on.:reset:");
elseif (argstr == "off" && !state)
  return player:notify(":bold::red:Color is already off.:reset:");
endif
if (argstr == "on")
  player.color = 1;
  return player:notify(":bold::green:Turned on color.:reset:");
elseif (argstr == "off")
  player.color = 0;
  return player:notify(":bold::green:Turned off color.:reset:");
else
  return player:notify(":bold::green:Turned off color.:reset:");
endif
.

.program #3:@talk
if (argstr != "on" && argstr != "off")
  player:notify(":bold::red:Usage: ", verb, " <on|off>:reset:");
  player:notify(":bold::blue:Current setting::reset: ", player.talk ? ":bold::green:ON:reset:" | "OFF");
  return;
endif
state = player.talk;
if (argstr == "on" && state)
  return player:notify(":bold::red:Talk is already on.:reset:");
elseif (argstr == "off" && !state)
  return player:notify(":bold::red:Talk is already off.:reset:");
endif
if (argstr == "on")
  player.talk = 1;
  return player:notify(":bold::green:Turned on talk.:reset:");
elseif (argstr == "off")
  player.talk = 0;
  return player:notify(":bold::green:Turned off talk.:reset:");
else
  return player:notify(":bold::green:Turned off talk.:reset:");
endif
.

.program #3:@prompt
if (argstr != "on" && argstr != "off")
  player:notify(":bold::red:Usage: ", verb, " <on|off>:reset:");
  player:notify("Current state: ", player.prompt ? "ON" | "OFF");
  return;
endif
state = player.prompt;
if (argstr == "on" && state)
  return player:notify(":bold::red:Prompt is already on.:reset:");
elseif (argstr == "off" && !state)
  return player:notify(":bold::red:Prompt is already off.:reset:");
endif
if (argstr == "on")
  player.prompt = 1;
  return player:notify(":bold::green:Turned on prompt.:reset:");
elseif (argstr == "off")
  player.prompt = 0;
  return player:notify(":bold::green:Turned off prompt.:reset:");
else
  return player:notify(":bold::green:Turned off prompt.:reset:");
endif
.

@verb #3 @create any any any

.program #3:@create
if (length(args) < 2)
return player:notify(":bold::red:Usage: ", verb, " <obj-parent> <name>:reset:");
endif
o = $obj(args[1]);
n = $listspc(@args[2..$]);
if (!valid(o))
return player:notify(":bold::red:", args[1], " is not a valid object.:reset:");
endif
try
b = create(o);
b.name = n;
b.owner = player;
player:notify(":bold::green:Created ", tostr(b), " ", n, " from parent object ", tostr(o), " ", o.name, ".:reset:");
return;
except (ANY)
return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@prop #0 protected 0
;$protected = {#0, #1, #2, #3, #4, #5, #6, #7}

@verb #3 @del*ete any any any

.program #3:@delete
if (!argstr)
return player:notify(":bold::red:Usage: ", verb, " <obj>:reset:");
endif
o = $getobj(args[1]);
if (!o && args[1] != "#0")
o = dobj;
endif
if (!valid(o))
return player:notify(":bold::red:", args[1], " is not a valid object.:reset:");
endif
if (o in ($protected))
on = o.name;
return player:notify(":bold::red:", tostr(o), " ", on, " cannot be deleted.:reset:");
endif
on = o.name;
if ($server_options.confirm_delete)
player:notify(":bold::yellow:Delete object ", tostr(o), " ", on, "?:reset:");
a = player:yesno();
else
a = 1;
endif
if (a)
recycle(o);
reset_max_object();
player:notify(":bold::green:", tostr(o), " ", on, " has been deleted.:reset:");
return;
else
player:notify(":bold::blue:", tostr(o), " ", on, " will not be deleted.:reset:");
endif
.

@verb #3 @cpverb any any any

.program #3:@cpverb
if (length(args) != 3)
return player:notify(":bold::red:Usage: ", verb, " <obj> <verb> <target-obj>:reset:");
endif
o = $getobj(args[1]);
v = args[2];
t = $getobj(args[3]);
if (o < #0)
return player:notify(":bold::red:Invalid object.:reset:");
endif
if (!v in (verbs(o)))
return player:notify(":bold::red:Verb not found.:reset:");
endif
if (t < #0)
return player:notify(":bold::red:Invalid target object.:reset:");
endif
if (v in (verbs(t)))
return player:notify(":bold::red:Verb \"", v, "\" already exists on ", tostr(t), " ", t.name, ".:reset:");
endif
add_verb(t, {#3, "rxd", verb_info(o, v)[3]}, verb_args(o, v));
set_verb_code(t, v, verb_code(o, v));
player:notify(":bold::green:Copied ", tostr(o), ":", tostr(v), " to ", tostr(t), " ", t.name, ".:reset:");
.

@verb #3 @rmverb any any any

.program #3:@rmverb
if (!argstr)
  return player:notify(":bold::red:Usage: rmverb <obj> <prop>:reset:");
endif
try
  object = $getobj(args[1]);
  if (object < #0)
    return player:notify(":bold::red:Invalid object.:reset:");
  endif
  delete_verb(object, args[2]);
  player:notify(":bold::green:Verb ", tostr(tostr(object)), ":", args[2], " deleted.:reset:");
except (ANY)
  return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #3 @rmprop any any any

.program #3:@rmprop
if (!argstr)
  return player:notify(":bold::red:Usage: rmprop <obj> <prop>:reset:");
endif
try
  object = $getobj(args[1]);
  delete_property(object, args[2]);
  player:notify(":bold::green:Property ", tostr(tostr(object)), ".", args[2], " deleted.:reset:");
except (ANY)
  return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

;"Login system"

.program #0:do_login_command
if (`!args || length(args) < 2 ! ANY')
if ($server_options.use_login_file && fileexists($server_options.directory, "login"))
for j in (fileread($server_options.directory, "login"))
notify(player, j);
endfor
else
if (typeof($server_options.login_screen) == STR)
notify(player, $server_options.login_screen);
else
for x in ($server_options.login_screen)
notify(player, x);
endfor
endif
endif
endif
if (`args[1] == "create" && length(args) == 4 ! ANY')
if (`args[1] == "create" && length(args) != 4 ! ANY')
notify(player, "Usage: create <username> <password> <email-address>");
boot_player(player);
endif
if (!$server_options.login_create)
notify(player, "User creation is disabled.");
boot_player(player);
return;
endif
users = {};
for z in (players())
users = listappend(users, z.name);
endfor
if (args[2] in users)
notify(player, "That user name is already taken.");
boot_player(player);
return;
endif
nu = create($user);
nu.name = args[2];
nu.password = crypt(args[3], $server_options.salt);
nu.email = args[4];
suspend(2);
move(nu, $user_start);
set_player_flag(nu, 1);
notify(player, "Created user " + nu.name + " (" + tostr(nu) + ").");
notify(player, "You may now login with that user name and password.");
return nu;
endif
if (`args[1] && args[2] ! ANY')
u = "";
p = #-1;
for u in (players())
if (u.name == args[1])
p = u;
endif
endfor
endif
if (`crypt(args[2], $server_options.salt) == p.password ! ANY')
return p;
elseif (`crypt(args[2], $server_options.salt) != p.password ! ANY')
notify(player, "Incorrect password.");
boot_player(player);
elseif (`args[1] == "quit" || args[1] == "q" ! ANY')
endif
.

@verb #0 user_connected this none this

.program #0:user_connected
p = args[1];
if (fileexists($server_options.directory, "motd"))
  notify(p, "");
  p:notify_lines(fileread($server_options.directory, "motd"));
  notify(p, "");
endif
p:notify(":bold::green:Currently connected from: ", p:addr(), ":reset:");
p.location:enterfunc(p);
.

@verb #2 enterfunc this none this

.program #2:enterfunc
if (args[1] in (connected_players()))
notify(args[1], tostr($bold, $purple, this.name, $reset));
endif
.

;"Internal private mail system"

@verb #3 @mail any any any

.program #3:@mail
if (!argstr)
  return player:notify(":bold::red:Usage: ", verb, " <user> [message]:reset:");
endif
if (!args[1] in $users()[2])
  return player:notify(":bold::red:User not found.:reset:");
endif
if (length(args) == 1)
  player:notify(":bold::green:Mail text::reset:");
  m = player:readlines();
else
  m = argstr[length(args[1]) + 2..$];
endif
try
  u = $users()[1][args[1] in $users()[2]];
  if (typeof(m) == LIST)
    send = {ctime(), player.name, m};
  else
    send = {ctime(), player.name, {m}};
  endif
  u.newmail = 1;
  u.mail = listinsert(u.mail, send, 1);
  if (u in connected_players())
    u:notify(":bold::green:You have new mail.:reset:");
  endif
  player:notify(":bold::green:Mail sent to ", u.name, " (", tostr(u), ").:reset:");
except (ANY)
  return player:notify(":bold::red:Unable to send mail to that user.:reset:");
endtry
.

@verb #3 @rmail any any any

.program #3:@rmail
if (!player.mail)
  return player:notify(":bold::red:You have no mail.:reset:");
endif
if (!argstr)
  player:notify(":bold::green:You have ", tostr(length(player.mail)), length(player.mail) > 1 ? " messages.:reset:" | " message.:reset:");
  c = 1;
  for x in (player.mail)
    player:notify(tostr(c), ": ", x[1], " ", x[2], " | ", length(x[3]) == 1 ? x[3][1] | x[3][1] + " [more]", ":reset:");
    c = c + 1;
  endfor
  player.newmail = 0;
else
  try
    t = toint(argstr);
    player:notify(":bold::green:Message: ", tostr(t), ":reset:");
    player:notify(":bold::green:Mail from ", player.mail[t][2], " received ", player.mail[t][1], " at ", player.mail[t][2], "::reset:");
    player:notify();
    if (typeof(player.mail[t][3] == STR))
      player:notify_lines(player.mail[t][3]);
    else
      player:notify_lines(player.mail[t][3]);
    endif
    player.newmail = 0;
  except (ANY)
    return player:notify(":bold::red:Unable to read that message.:reset:");
  endtry
endif
.

@verb #3 @delmail any any any

.program #3:@delmail
if (!player.mail)
  return player:notify(":bold::red:You have no mail.:reset:");
endif
if (!argstr)
  return player:notify(":bold::red:Usage: ", verb, " <message-number>:reset:");
endif
n = toint(argstr);
if (n > length(player.mail))
  return player:notify(":bold::red:Message number out of range.:reset:");
endif
try
  player.mail = listdelete(player.mail, n);
  player:notify(":bold::green:Message ", tostr(n), " deleted.:reset:");
  return;
except (ANY)
  return player:notify(":bold::red:Could not delete that message.:reset:");
endtry
.

@verb #3 @who any any any

.program #3:@who
player:notify(":bold::blue:Connected users (", tostr(length(connected_players())), ")::reset:");
for x in (connected_players())
  player:notify(":green:", x.name, " (", tostr(x), ") [", parent(x).name, "] :blue:@:cyan: ", x.location.name, ":reset:");
endfor
.

@verb #3 @verbs any any any

.program #3:@verbs
if (!argstr)
  return player:notify(":bold::red:Usage: ", verb, " <obj>:reset:");
endif
o = $getobj(args[1]);
try
  player:notify(":bold::green:", length(verbs(o)), " verbs on ", tostr(o), ": ", $liststr(@verbs(o)), ":reset:");
except (ANY)
  return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #3 @props any any any

.program #3:@props
if (!argstr)
  return player:notify(":bold::red:Usage: props <obj>:reset:");
endif
try
  object = $getobj(args[1]);
  if (object < #0)
    player:notify(":bold::red:Invalid object.");
  endif
  if (!properties(object))
    return player:notify(":bold::red:No properties defined on ", tostr(object), ".:reset:");
  endif
  player:notify(":bold::green:Property list for ", tostr(tostr(object)), "::reset:");
  player:notify("");
  for x in (properties(object))
    player:notify(":bold::cyan:", tostr(object), ".", x, " = ", tostr(toliteral(object.(x))), ":reset:");
  endfor
  "player:notify(tostr(toliteral(properties(object))));";
  player:notify("");
  player:notify(":bold::cyan:", tostr(length(properties(object))), " total properties on ", object.name, ":reset:");
except (ANY)
  return player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #0 vsize this none this

.program #0:vsize
if (length(args) < 2)
  return player:notify(":bold::red:Usage: ", verb, " <obj> <verb>:reset:");
endif
object = $getobj(args[1]);
if (!valid(object))
  return player:notify(":bold::red:Invalid object.:reset:");
endif
if (!args[2] in verbs(object))
  return player:notify(":bold::red:Verb not found on that object.:reset:");
endif
b = 0;
try
  for x in (verb_code(object, args[2]))
    b = b + length(x);
  endfor
  s = tofloat(b);
  si = toint(b);
  ck = s / 1024.0;
  cm = s / 1048576.0;
  if (s < 1024.0)
    cs = tostr(si) + " " + "bytes";
  elseif (s >= 1024.0 && s < 1048576.0)
    cs = floatstr(ck, 2) + " " + "KB";
  elseif (s >= 1048576.0)
    cs = floatstr(cm, 2) + " " + "MB";
  endif
  return player:notify(":bold::green:", cs, ":reset:");
except (ANY)
  return player:notify(":bold::red:Error in vsize function.:reset:");
endtry
.

@verb #3 "@code @ncode" any any any

.program #3:@code
if (!argstr)
  return player:notify(":bold::red:Usage: ", verb, " <obj> <verb>:reset:");
endif
try
  object = $getobj(args[1]);
  player:notify(":bold::green:Verb information: ", tostr(verb_info(object, args[2])[1]), " ", verb_info(object, args[2])[2], " \"", verb_info(object, args[2])[3], "\":reset:");
  player:notify(":bold::green:Verb arguments: ", verb_args(object, args[2])[1], " ", verb_args(object, args[2])[2], " ", verb_args(object, args[2])[3], ":reset:");
  player:notify(":bold::green:Verb code for ", tostr(object), ":", args[2], "::reset:");
  player:notify(":bold::cyan:.program ", tostr(object), ":", args[2], "");
  if (verb == "@ncode")
    y = 0;
    v = {};
    for x in (verb_code(object, args[2]))
      y = y + 1;
      v = listappend(v, tostr(tostr(y), ": ", tostr(x)));
    endfor
    player:notify_lines_nocolor(v);
    player:notify(":bold::cyan:.:reset:");
    $vsize(@{tostr(object), args[2]});
    return;
  else
    player:notify_lines_nocolor(verb_code(object, args[2]));
    player:notify(":bold::cyan:.:reset:");
    $vsize(@{tostr(object), args[2]});
    return;
  endif
except (ANY)
  player:notify(":bold::red:Improper '", verb, "' command.:reset:");
endtry
.

@verb #3 @password any any any

.program #3:@password
if (!argstr)
  player:notify(":bold::green:Enter a new password::reset:");
  np = read();
else
  np = argstr;
endif
if (!np)
  return player:notify(":bold::red:Blank password entry; password has not been changed.:reset:");
else
  player.password = crypt(np, $server_options.salt);
  player:notify(":bold::green:Password changed.:reset:");
  return;
endif
player:notify(":bold::red:Password not changed.:reset:");
.

@verb #3 @quit any any any

.program #3:@quit
boot_player(player);
.

@verb #3 @dd any any any

.program #3:@dd
player:notify(":bold::green:Database saved.:reset:");
dump_database();
.

@verb #3 @obj any any any

.program #3:@obj
player:notify(":bold::green:Database Objects::reset:");
player:notify();
for x in [0..toint(max_object())]
  player:notify(":bold::cyan:", tostr(toobj(x)), " ", toobj(x).name, ":reset:");
endfor
.

@verb #3 @move any any any

.program #3:@move
try
  if (length(args) != 2)
    return player:notify(":bold::red:Usage: ", verb, " <object> <location>:reset:");
  endif
  a = $getobj(args[1]);
  b = $getobj(args[2]);
  if (!valid(a))
    return player:notify(":bold::red:\"", args[1], "\" is not a valid object.:reset:");
  elseif (!valid(b))
    return player:notify(":bold::red:\"", args[2], "\" is not a valid object.:reset:");
  else
    move(a, b);
    player:notify(":bold::green:Moved ", a.name, " (", tostr(a), ") to ", b.name, " (", tostr(b), ").:reset:");
  endif
except (ANY)
  return player:notify(":bold::red:Move operation failed.:reset:");
endtry
.

;"User and Administrator objects are created, and the values of $admin and $user are changed accordingly."
;"User is created first, therefore is the parent object of Administrator."
;"Administrator will have many of the same properties and verbs as User."

@create #1 User
;$user = #5
;$user.r = 1
;$user.f = 1
@create $user Administrator
;$admin = #6
;$admin.r = 1
;$admin.f = 1

;"Adds the properties from #3 to $user."

@prop $user color 1
@prop $user modules 0
;$user.modules = {}
@prop $user password "(account disabled)"
@prop $user prompt 1
@prop $user email "(not set)"
@prop $user mail 0
;$user.mail = {}
@prop $user newmail 0
@prop $user talk 1
@prop $user rootdir "/satyr"
@prop $user realname "(not set)"

;"Copies programmed verbs to $user and $admin."

@cpverb #3 notify $user
@cpverb #3 notify_lines $user
@cpverb #3 notify_lines_nocolor $user
@cpverb #3 readlines $user
@cpverb #3 yesno $user
@cpverb #3 addr $user
@cpverb #3 @mail $user
@cpverb #3 @rmail $user
@cpverb #3 @delmail $user
@cpverb #3 @password $user
@cpverb #3 @who $user
@cpverb #3 @users $user
@cpverb #3 @color $user
@cpverb #3 @talk $user
@cpverb #3 @prompt $user
@cpverb #3 @quit $user
@cpverb #3 @create $admin
@cpverb #3 @delete $admin
@cpverb #3 @mkuser $admin
@cpverb #3 @mkadmin $admin
@cpverb #3 @obj $admin
@cpverb #3 @move $admin
@cpverb #3 @dd $admin
@cpverb #3 @verb $admin
@cpverb #3 @verbinfo $admin
@cpverb #3 @args $admin
@cpverb #3 @cfile $admin
@cpverb #3 @fcode $admin
@cpverb #3 @verbs $admin
@cpverb #3 @cpverb $admin
@cpverb #3 @rmverb $admin
@cpverb #3 @code $admin
@cpverb #3 @script $admin
@cpverb #3 @prop $admin
@cpverb #3 @props $admin
@cpverb #3 @rmprop $admin

;"Creates a verb to remove all verbs and properties from #3; they are now on $user and $admin."

@verb me @_clear-self_ any any any

.program me:@_clear-self_
for x in (verbs(player))
delete_verb(player, x);
endfor
notify(player, "Verbs removed.");
for x in (properties(player))
delete_property(player, x);
endfor
notify(player, "Properties removed.");
.

;"Makes a new account for the main administrator."
;"Since you will be disconnected, change your password here if you prefer."
;"This can always be changed with @password later. E-mail address can also be changed using 'eval (;)'."

@mkadmin Admin PASSWORD email@address.com

;"Deletes all properties and commands on #3."

@_clear-self_

.program #0:do_command
.

;chparent(player, $admin)

;"$do_command needed to be cleared for the previous line to work correctly. It is now changed back to its original state."

.program #0:do_command
try
d = {"north", "south", "east", "west", "northeast", "northwest", "southeast", "southwest", "up", "down", "n", "s", "e", "w", "ne", "nw", "se", "sw", "u", "d"};
a = {};
if (argstr in (d))
return 0;
endif
for z in (args)
  if (z != args[1])
    a = listappend(a, z);
  endif
endfor
if (args[1][1] != "@" && args[1][1] != ";")
  player.location:say(@args);
  return 1;
elseif (args[1][1] == "@" && !args[1][1] != ";")
  for x in (player.modules)
    for y in (verbs(x))
      if (args[1] == y)
        x:(y)(@a);
        return 1;
      endif
    endfor
  endfor
else
  if (player.prompt)
    string = ":cyan:" + player.name + ":purple:@:cyan:" + player.location.name + ":purple:>:bold::purple:" + $listspc(@args) + ":reset:";
    player:notify(string);
    return 0;
  else
    return 0;
  endif
endif
except (ANY)
return 0;
endtry
.

;"Disables the root account and logs out."
;"You may log back in with username: Admin   password: PASSWORD"
;"as set above."

;player.password = "(account disabled)";

@quit
